<template>
  <div class="fr-col-lg-8">
    <FrTitle larger class="anct-printable-content">
      {{ solution.title }}
    </FrTitle>

    <div v-if="isIncubationPage" class="fr-grid-row">
      <FrTile
        class="fr-col-12 fr-col-lg-5 fr-mr-4w fr-mb-4w"
        title="Comment choisir votre licence libre ?"
        to="https://licence-libre.incubateur.anct.gouv.fr/"
        image-path="/images/licence_libre_icon.svg"
        horizontal
      />

      <FrTile
        class="fr-col-12 fr-col-lg-5"
        title="Bien documenter le déploiement d’un projet open source"
        to="https://outline.incubateur.anct.gouv.fr/share/39eb21f2-167c-4f98-a313-22ccedfc5246"
        image-path="/images/ops_documentation_icon.svg"
        horizontal
      />
    </div>

    <section class="anct-html-content fr-my-5w anct-printable-content">
      <div v-html="markdownToHTML(solution.introduction)" />
    </section>

    <div id="solution" class="anct-html-content anct-printable-content">
      <section class="fr-mb-5w anct-bg-blue">
        <div class="fr-p-4w fr-pl-5w" v-html="solution.target" />
      </section>

      <div class="anct-flex-center">
        <FrTile
          class="fr-col-12 fr-col-lg-5 fr-mr-4w fr-mb-4w"
          title="Découvrez les communes ayant été accompagnées"
          to="/offre/accompagnement-sur-mesure/catalogue"
          image-path="/images/licence_libre_icon.svg"
          horizontal
        />
        <FrTile
          class="fr-col-12 fr-col-lg-5 fr-mr-4w fr-mb-4w"
          title="Questions fréquemment posées"
          to="/offre/accompagnement-sur-mesure/faq"
          image-path="/images/logo_incubateur.svg"
          horizontal
        />
      </div>

      <section class="fr-mb-5w">
        <div v-html="solution.description" />
      </section>

      <section v-if="solution.highlight" class="fr-mb-5w anct-bg-blue">
        <div class="fr-p-4w fr-pl-5w">
          <div v-html="solution.highlight" />
          <FrExternalLinkButton
            v-if="customContactButtonExists(solution)"
            :href="solution.highlight_contact_button_url"
            title="Accéder au site du service"
            secondary
          >
            {{ solution.highlight_contact_button }}
          </FrExternalLinkButton>
          <FrLinkButton
            v-else-if="solution.highlight_contact_button"
            :to="{ name: 'contact' }"
            class="fr-btn--secondary fr-mt-3w"
            @click.native="trackContactClick"
          >
            {{ solution.highlight_contact_button }}
          </FrLinkButton>
        </div>
      </section>
      <section v-if="solution.detail" class="fr-mb-5w">
        <div v-html="solution.detail" />
        <FrLinkButton
          v-if="solution.detail_catalog_button"
          :to="{ name: 'services' }"
          class="fr-btn--secondary fr-mt-3w"
        >
          {{ solution.detail_catalog_button }}
        </FrLinkButton>
      </section>

      <section v-if="solution.additional_info" class="fr-mb-5w">
        <div class="fr-mb-5w" v-html="solution.additional_info" />
        <div
          v-if="solution.video"
          class="anct-video-container anct-not-printable"
        >
          <iframe
            :src="solution.video"
            title="YouTube video player"
            allow="accelerometer; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
            allowfullscreen
          >
          </iframe>
        </div>
      </section>
    </div>
  </div>
</template>

<script>
import { marked } from 'marked';
import FrLinkButton from '~/components/ui/LinkButton';
import FrExternalLinkButton from '~/components/ui/ExternalLinkButton';
import FrTitle from '~/components/ui/Title';
import FrTile from '~/components/elements/Tile';

export default {
  name: 'SolutionItemPage',

  components: { FrExternalLinkButton, FrLinkButton, FrTitle, FrTile },

  async asyncData({ $axios, params, redirect }) {
    const { data } = await $axios.$get('/items/offres', {
      params: {
        fields:
          'introduction,target,title,description,highlight,highlight_contact_button,highlight_contact_button_url,detail,detail_catalog_button,additional_info,video',
      },
    });

    const [solution] = data;

    if (!solution) {
      return redirect({ name: 'offre' });
    }

    return {
      solution,
    };
  },

  computed: {
    isIncubationPage() {
      const INCUBATION_PAGE_NAME = 'incubateur-services-numeriques';
      return this.$route.params.slug === INCUBATION_PAGE_NAME;
    },
  },

  methods: {
    markdownToHTML(markdown) {
      return marked.parse(markdown);
    },
    customContactButtonExists(solution) {
      return !!(
        solution.highlight_contact_button &&
        solution.highlight_contact_button_url
      );
    },
  },
};
</script>

<style scoped>
/deep/ .anct-html-content p {
  font-size: inherit;
  margin-bottom: 0;
}

/deep/ .anct-html-content ol,
/deep/ .anct-html-content ul {
  margin-left: 24px;
  margin-bottom: 16px;
}

.anct-video-container {
  height: 0;
  overflow: hidden;
  padding-bottom: 50%;
  position: relative;
}

.anct-video-container iframe {
  height: 100%;
  left: 0;
  max-width: 800px;
  position: absolute;
  top: 0;
  width: 100%;
  border: none;
}
</style>
